#!/usr/bin/perl -w
use strict;


##################################################################################################

## This code converts the taxonomic summary files in rdp format to bin_stats format
## Requires file : names_uniq.dmp
#USAGE: perl convert_rdp2binstats <INPUT_TAXONOMIC SUMMARY_IN_RDP_FORMAT>
#OUTPUT: INPUT_FILE_TAXONOMIC SUMMARY_IN_RDP_FORMAT.bin_stats


##################################################################################################


my %genus_fractions;
my %names_hash;
my %rank_hash;
my %tax_names_hash;
my $names_hash_file = "names_uniq.dmp";
open(OUT,">$ARGV[0].bin_stats");
open(NAMES_HASH,$names_hash_file);
while(<NAMES_HASH>)
{
	my $line = $_;
	chomp $line;
	my @names_arr = split(/\t/,$line);
	$names_hash{$names_arr[1]} = $names_arr[0];
	$rank_hash{$names_arr[0]} = $names_arr[2];
	$tax_names_hash{$names_arr[0]} = $names_arr[1];
}
my %assigned_numbers;
my $header;
my $last_header = 'XX';
my $last_assignment = '';
my $assigned_at;
open(IN,"$ARGV[0]");
while(<IN>)
{
	my $FF = $_;
	chomp $FF;
	my @b = split(/\t/,$FF);
	my $i = 0;
	$assigned_at = '';
	for($i=4;$i<=$#b;$i=$i+3)
	{
=head
		if(exists $genus_fractions{$b[$i]})
		{
			if($b[$i+1] < $genus_fractions{$b[$i]})
			{
				$assigned_at = $b[$i-2];
				last;
			}
		}
=cut
		if($b[$i] < 0.80)
		{
			$assigned_at = $b[$i-2];
			$b[$i-2] =~ s/\"//g;
			if(exists $assigned_numbers{$b[$i-2]})
			{
				$assigned_numbers{$b[$i-2]} += 1;
			}
			else
			{
				$assigned_numbers{$b[$i-2]} = 1;
			}
			last;
		}
	}
	if($assigned_at eq '')
	{
		$assigned_at = $b[$#b-2];
		#print "last:$b[$#b-2]\n";
		$b[$#b-2] =~ s/\"//g;
		if(exists $assigned_numbers{$b[$#b-2]})
		{
			$assigned_numbers{$b[$#b-2]} += 1;
		}
		else
		{
			$assigned_numbers{$b[$#b-2]} = 1;
		}
	}
			
}
foreach my $ckeys (keys %assigned_numbers)
{
	if(exists $names_hash{$ckeys})
	{
		print OUT "$names_hash{$ckeys}\t$ckeys\t$assigned_numbers{$ckeys}\n";
	}
}
close(OUT);
